/* --------------------------------------------------------- */
/*	BASIC-E for Windows										 */
/*	Copyright(C)2006 t.hara									 */
/* ========================================================= */
/*	Zaurus frame memory simulator							 */
/* --------------------------------------------------------- */

#ifndef __ZAURUS_FRAME_H__
#define __ZAURUS_FRAME_H__

#include <windows.h>

/* --------------------------------------------------------- */
class c_zaurus_vram {
private:
	unsigned short*	p_virtual_vram;
	unsigned short* p_physical_vram;

public:
	/* for windows */
	c_zaurus_vram( void ): p_virtual_vram(0), p_physical_vram(0) {
	}

	~c_zaurus_vram() {
		release();
	}
	
	void initialize( void ) {
		release();
		p_virtual_vram	= new unsigned short [ 480 * 640 ];
		p_physical_vram	= new unsigned short [ 640 * 480 ];

		memset( p_virtual_vram, 0, 480 * 640 * 2 );
	}

	void release( void ) {
		delete[] p_physical_vram;
		delete[] p_virtual_vram;
	}

	void rotate_transfer( void );

	unsigned short *get_physical_vram( void ) const  {
		return p_physical_vram;
	}
 
	unsigned short *get_virtual_vram( void ) const {
		return p_virtual_vram;
	}
};

#endif
