/* --------------------------------------------------------- */
/*	BASIC-E GRAPHIC layer									 */
/*	Copyright(C)2006 t.hara									 */
/* ========================================================= */
/*	graphic screen layer									 */
/* --------------------------------------------------------- */

#ifndef __GRAPHIC_LAYER_H__
#define __GRAPHIC_LAYER_H__

#include <cstring>
using namespace std;

class c_graphic_layer {
private:
	int	width;
	int	height;
	unsigned short *p_image;

public:
	c_graphic_layer( void ): width(0), height(0), p_image(0) {
	}
	
	~c_graphic_layer() {
	}

	void create( int width, int height ) {
		release();
		p_image = new unsigned short [ width * height ];
		memset( p_image, 0, width * height * sizeof(unsigned short) );
		this->width  = width;
		this->height = height;
	}

	void release( void ) {
		delete[] p_image;
		p_image = 0;
	}

	unsigned short get_pixel( int index ) {
		return p_image[ index ];
	}

	void set_pixel( int x, int y, unsigned short color ) {
		if( static_cast<unsigned>( y ) >= static_cast<unsigned>( width  ) ) return;
		if( static_cast<unsigned>( x ) >= static_cast<unsigned>( height ) ) return;
		p_image[ (width - y - 1) + x * width ] = color;
	}
};

/* (MSB) {rrrrrggggggbbbbb} (LSB)	*/
#define rgb_color( r, g, b )	( ((b) & 31) | (((g) & 63) << 5) | (((r) & 31) << 11) )

#endif
