/* --------------------------------------------------------- */
/*	BASIC-E													 */
/*	Copyright(C)2006 t.hara									 */
/* ========================================================= */
/*	keyboard manager										 */
/* --------------------------------------------------------- */

#include "system_resource.h"
#include "key_manager.h"

/* --------------------------------------------------------- */
void c_keyboard::push_key( int code ) {
	p_res->p_callback->lock();
	key_buffer.push( code );
	p_res->p_callback->unlock();
}

/* --------------------------------------------------------- */
int c_keyboard::pop_key( void ) {
	int code = 0;
	p_res->p_callback->lock();
	if( key_buffer.is_buffered() ) {
		code = key_buffer.pop();
	}
	p_res->p_callback->unlock();
	return code;
}

/* --------------------------------------------------------- */
bool c_keyboard::kbhit( void ) {
	bool result;
	p_res->p_callback->lock();
	result = key_buffer.is_buffered();
	p_res->p_callback->unlock();
	return result;
}

/* --------------------------------------------------------- */
void c_keyboard::clear_keybuffer( void ) {
	p_res->p_callback->lock();
	key_buffer.clear();
	p_res->p_callback->unlock();
}
