/* --------------------------------------------------------- */
/*	BASIC-E													 */
/*	Copyright(C)2006 t.hara									 */
/* ========================================================= */
/*	FIFO buffer												 */
/* --------------------------------------------------------- */

#ifndef __QUEUE_H__
#define __QUEUE_H__

template <class c_object, int size = 128>
class c_queue {
private:
	c_object	fifo[ size ];
	int			push_point;
	int			pop_point;
public:
	c_queue( void ) {
		push_point	= 0;
		pop_point	= 0;
	}

	~c_queue() {
	}

	void push( c_object o ) {
		int next_push_point;

		next_push_point = (push_point + 1) % size;
		if( next_push_point == pop_point ) {
			/* overflow FIFO buffer */
			return;
		}
		fifo[ push_point ] = o;
		push_point = next_push_point;
	}

	bool is_buffered( void ) {
		if( push_point == pop_point ) {
			return false;
		}
		return true;
	}

	c_object pop( void ) {
		c_object o = fifo[ pop_point ];
		pop_point = (pop_point + 1) % size;
		return o;
	}

	void clear( void ) {
		push_point	= 0;
		pop_point	= 0;
	}
};

#endif
