/* --------------------------------------------------------- */
/*	BASIC-E													 */
/*	Copyright(C)2006 t.hara									 */
/* ========================================================= */
/*	FILO buffer												 */
/* --------------------------------------------------------- */

#ifndef __STACK_H__
#define __STACK_H__

template <class c_object, int size = 128>
class c_stack {
private:
	c_object	filo[ size ];
	int			push_point;
public:
	c_stack( void ) {
		push_point	= 0;
	}

	~c_stack() {
	}

	void clear( void ) {
		push_point = 0;
	}

	bool is_full( void ) {
		return( push_point >= size );
	}

	void push( c_object o ) {

		if( push_point == size ) {
			/* overflow filo buffer */
			return;
		}
		filo[ push_point ] = o;
		push_point++;
	}

	bool is_buffered( void ) {
		return( push_point > 0 );
	}

	c_object pop( void ) {
		push_point--;
		return filo[ push_point ];
	}
};

#endif
