/* --------------------------------------------------------- */
/*	BASIC-E													 */
/* ========================================================= */
/*	Copyright(C) 2006 t.hara								 */
/*	system resource											 */
/* --------------------------------------------------------- */

#ifndef __SYSTEM_RESOURCE_H__
#define __SYSTEM_RESOURCE_H__

class c_system_resource;

#include "graphic_layer.h"
#include "text_layer.h"
#include "text_editor.h"
#include "interpreter.h"
#include "variable_manager.h"
#include "key_manager.h"

/* --------------------------------------------------------- */
class c_basic_e_callback {
public:
	c_basic_e_callback() {
	}
	virtual ~c_basic_e_callback() {
	}
	virtual void sleep( unsigned int msec ) = 0;
	virtual void lock( void ) = 0;
	virtual void unlock( void ) = 0;
	virtual void update_screen( void ) = 0;
	virtual void update_text( void ) = 0;
};

/* --------------------------------------------------------- */
class c_system_resource {
public:
	volatile bool			f_running;
	bool					f_program_running;
	int						error_code;
	c_graphic_layer			*p_graphic_screen;
	c_text_layer			*p_text_screen;
	c_text_editor			*p_text_editor;
	c_interpreter			*p_interpreter;
	c_variable_manager		*p_variable_manager;
	c_basic_e_callback		*p_callback;
	c_keyboard				*p_keyboard;
};

#endif
